#! /bin/sh

# --------------------------------------------------------------------------
#  PRI ADAPTER CONFIGURATION SCRIPT
#  Copyright by Eicon Networks 1993-2000
# --------------------------------------------------------------------------

adapter=$1
diva_dir=$2
pri_adapter_name=$3

# -------------------------------------------------------------------------
# Declare all variables here
# -------------------------------------------------------------------------
eicon_proc=/proc/net/eicon
config_valid=0
generic_profile=0
protocol=0
protocol_string="ETSI"
l1_options=4
z_options=2
ext_options=2
nt2_mode=2
didn_length=100
pri_fractional_yes=2
pri_num_channels=30
pri_lo_channel=100
pri_own_tei=100
pri_own_tei_yes=2
law_options=100
pri_ringer_tone=255
pri_rbscas_didd=257
pri_rbscas_rx_digit_to=257
pri_rbscas_glare=257
pri_rbscas_bc=257
pri_rbscas_answer_to=257
pri_rbscas_trunk_mode=257
pri_rbscas_trunk_dial_type=257


# -------------------------------------------------------------------------
# This finction is used to seelect generic configuration
# as result it does set 'generic_profile' to one value [1...4]
# -------------------------------------------------------------------------
divas_pri_generic_profile()
{
clear
echo ' -------------------------------------------------------------------------------'
echo "                PLEASE SELECT OPERATION MODE FOR"
echo "                $pri_adapter_name"
echo ' -------------------------------------------------------------------------------'
echo ' 1 - E1/T1 TE mode operation with D-channel'
echo ' 2 - E1/T1 NT mode operation with D-channel'
echo '     Typical usage (1,2): RAS Server, FAX Server, Unified Messaging Server,'
echo '                          Wireless Access Server, WAP Server,'
echo '                          VoIP (Media Gateway),'
echo '                          PABX or Link between 2 PABX'
echo
echo ' 3 - Permanent connection, TE <--> TE mode (structured line)'
echo ' 4 - Permanent connection, NT <--> TE mode (unstructured line), TE side'
echo ' 5 - Permanent connection, NT <--> TE mode (unstructured line), NT side'
echo '     Typical usage (3-5): LAN to LAN coupling (E1:2MBit or T1:1.5Mbit)'
echo ' -------------------------------------------------------------------------------'

echo -e "Your selection [1]: \c"
read generic_profile
if [ -z $generic_profile ]
then
generic_profile=1
fi
case $generic_profile in
  1)
     ;;

  2)
     ;;

  3) z_options=0
     nt2_mode=0
     pri_fractional_yes=0
     pri_own_tei_yes=0
     ;;

  4) z_options=0
     nt2_mode=0
     pri_fractional_yes=0
     pri_own_tei_yes=0
     ;;
  5) z_options=0
     nt2_mode=0
     pri_fractional_yes=0
     pri_own_tei_yes=0
     ;;

  *) generic_profile=0
     ;;
esac
}

# ----------------------------------------------------------------------------
#  Select D-Channel protocol and write it in protocol variable
# ----------------------------------------------------------------------------
divas_pri_protocol()
{
clear
echo ' -------------------------------------------------------------------------------'
echo '                PLEASE SELECT D-CHANNEL PROTOCOL (SWITCH TYPE)'
echo ' -------------------------------------------------------------------------------'
echo '  1 - 1TR6     Germany, old protocol for PABX'
echo '  2 - ETSI     DSS1, Europe, Germany'
echo '  3 - FRANC    VN3, France, old protocol for PABX'
echo '  4 - BELG     NET3, Belgium, old protocol for PABX'
echo '  5 - SWED     DSS1 with CRC4 off, Sweden, Benelux'
echo '  6 - NI       NI1, NI2, North America, National ISDN'
echo '  7 - 5ESS     5ESS, North America, AT&T'
echo '  8 - JAPAN    Japan, INS-NET64'
echo '  9 - ATEL     ATEL, Australia, old TPH1962'
echo ' 10 - ITALY    DSS1, Italy'
echo ' 11 - TWAN     DSS1, Taiwan'
echo ' 12 - AUSTRAL  Australia, Microlink, TPH1962, On Ramp ETSI'
echo ' 13 - 4ESS_SDN 4ESS Software Defined Network'
echo ' 14 - 4ESS_SDS 4ESS Switched Digital Service'
echo ' 15 - 4ESS_LDS 4ESS Long Distance Service'
echo ' 16 - 4ESS_MGC 4ESS Megacom'
echo ' 17 - 4ESS_MGI 4ESS Megacom International'
echo ' 18 - HONGKONG Hongkong'
echo ' 19 - RBSCAS   Robbed Bit Signaling, CAS'
echo ' 20 - QSIG     QSIG, Intra PABX link protocol'
#echo ' 28 - E1UNCH   UnChannelized E1 (no sig, single channel group)'
#echo ' 29 - T1UNCH   Unchannelized T1 (no sig, single channel group)'
#echo ' 30 - E1CHAN   Channelized E1 (no sig, multible channel groups)'
#echo ' 31 - T1CHAN   Channelized T1 (no sig, multible channel groups)'
echo ' -------------------------------------------------------------------------------'
echo -e "Your selection: \c"
read protocol

case $protocol in
 1) protocol_string="1TR6"
    protocol=1
  ;;
 2) protocol_string="ETSI"
    protocol=2
  ;;
 3) protocol_string="FRANC"
    protocol=3
  ;;
 4) protocol_string="BELG"
    protocol=4
  ;;
 5) protocol_string="SWED"
    protocol=5
  ;;
 6) protocol_string="NI"
    pri_num_channels=23
    protocol=6
  ;;
 7) protocol_string="5ESS"
    pri_num_channels=23
    protocol=7
  ;;
 8) protocol_string="JAPAN"
    protocol=8
  ;;
 9) protocol_string="ATEL"
    protocol=9
  ;;
10) protocol_string="ITALY"
    protocol=10
  ;;
11) protocol_string="TWAN"
    protocol=11
  ;;
12) protocol_string="AUSTRAL"
    protocol=12
  ;;
13) protocol_string="4ESS_SDN"
    pri_num_channels=23
    protocol=13
  ;;
14) protocol_string="4ESS_SDS"
    pri_num_channels=23
    protocol=14
  ;;
15) protocol_string="4ESS_LDS"
    pri_num_channels=23
    protocol=15
  ;;
16) protocol_string="4ESS_MGC"
    pri_num_channels=23
    protocol=16
  ;;
17) protocol_string="4ESS_MGI"
    pri_num_channels=23
    protocol=17
  ;;
18) protocol_string="HONGKONG"
    protocol=18
  ;;
19) protocol_string="RBSCAS"
    pri_num_channels=24
    pri_own_tei_yes=0
    pri_ringer_tone=0
    protocol=19
  ;;
20) protocol_string="QSIG"
    protocol=20
  ;;
28) protocol_string="E1UNCH"
    protocol=28
  ;;
29) protocol_string="T1UNCH"
    protocol=29
  ;;
30) protocol_string="E1CHAN"
    protocol=30
  ;;
13) protocol_string="T1CHAN"
    protocol=31
  ;;
 *)
    protocol=0
  ;;
esac
}


# ----------------------------------------------------------------------------
#  RBAS CAS DIGIT TO
# ----------------------------------------------------------------------------
pri_get_rbscas_rx_digit_to()
{
clear
local_default=10
echo ' -------------------------------------------------------------------------------'
echo '             RX DIGIT TIMEOUT, SECONDS'
echo '             (specify the time interval, in seconds, that may pass'
echo '             between the incoming dialed digits. If the specified interval'
echo '             is exceeded, the dialed number is assumed to be complete and'
echo '             the call is forwarded to the application)'
echo ' -------------------------------------------------------------------------------'
if [ $((generic_profile)) -eq 1 ]
then
local_default=10
else
local_default=15
fi
echo -e "Your selection (1...255)[$local_default]: \c"
read pri_rbscas_rx_digit_to
if [ -z $pri_rbscas_rx_digit_to ]
then
pri_rbscas_rx_digit_to=$local_default
fi
pri_rbscas_rx_digit_to=$((pri_rbscas_rx_digit_to))
if [ $((pri_rbscas_rx_digit_to)) -eq 0 ]
then
pri_rbscas_rx_digit_to=257
fi
if [ $((pri_rbscas_rx_digit_to)) -ge 256 ]
then
pri_rbscas_rx_digit_to=257
fi
}

# ----------------------------------------------------------------------------
#  RBAS CAS GLARE RESOLVE
# ----------------------------------------------------------------------------
pri_get_rbscas_glare()
{
local_default="N"
clear
echo ' -------------------------------------------------------------------------------'
echo '             GLARE-RESOLVING PARTY'
echo '             No  - When a call collision occurs, your server will not'
echo '                   abort its call attempt to resolve the collision but'
echo '                   will wait for the other party to do so.'
echo '             Yes - When a call collision occurs, your server will stop'
echo '                   dialing and return to on-hook status.'
echo ' -------------------------------------------------------------------------------'
if [ $((generic_profile)) -eq 1 ]
then
local_default="Y"
else
local_default="N"
fi
echo -e "Your selection (Y/N)[$local_default]: \c"
read pri_rbscas_glare
if [ -z $pri_rbscas_glare ]
then
pri_rbscas_glare=$local_default
fi
case $pri_rbscas_glare in
  Y) pri_rbscas_glare=1
    ;;
  y) pri_rbscas_glare=1
    ;;
  N) pri_rbscas_glare=0
    ;;
  n) pri_rbscas_glare=0
    ;;
  *) pri_rbscas_glare=257
    ;;
esac
}

# ----------------------------------------------------------------------------
#  RBAS CAS BC
# ----------------------------------------------------------------------------
pri_get_rbscas_bc()
{
clear
echo ' -------------------------------------------------------------------------------'
echo '             SIGNAL CALLS TO APPLICATION AS'
echo '             A - Voice/Analog (3.1 kHz audio)'
echo '                 Select this value if your application handles'
echo '                 voice calls, fax group III, and analog modem calls'
echo '             D - Data/Digital (56 kbps rate adaptation HDLC)'
echo '                 Select this value if your application handles'
echo '                 digital calls, e.g. digital RAS'
echo ' -------------------------------------------------------------------------------'
echo -e "Your selection (A/D)[A]: \c"
read pri_rbscas_bc
if [ -z $pri_rbscas_bc ]
then
pri_rbscas_bc="A"
fi
case $pri_rbscas_bc in
  A) pri_rbscas_bc=4
    ;;
  a) pri_rbscas_bc=4
    ;;
  D) pri_rbscas_bc=8
    ;;
  d) pri_rbscas_bc=8
    ;;
  *) pri_rbscas_bc=257
    ;;
esac
}

# ----------------------------------------------------------------------------
#  RBAS CAS ANSWER TO
# ----------------------------------------------------------------------------
pri_get_rbscas_answer_to()
{
clear
echo ' -------------------------------------------------------------------------------'
echo '             ANSWER TIMEOUT'
echo '             (Set the time interval, in seconds, after which the'
echo '             adapter hangs up if the remote station does not answer a call)'
echo ' -------------------------------------------------------------------------------'
echo -e "Your selection (1...255)[120]: \c"
read pri_rbscas_answer_to
if [ -z $pri_rbscas_answer_to ]
then
pri_rbscas_answer_to=120
fi
pri_rbscas_answer_to=$((pri_rbscas_answer_to))
if [ $((pri_rbscas_answer_to)) -eq 0 ]
then 
pri_rbscas_answer_to=257
fi
if [ $((pri_rbscas_answer_to)) -ge 256 ]
then 
pri_rbscas_answer_to=257
fi
}

# ----------------------------------------------------------------------------
#  RBAS CAS TRUNK MODE
# ----------------------------------------------------------------------------
pri_get_rbscas_trunk_mode()
{
clear
echo ' -------------------------------------------------------------------------------'
echo '             TRUNK MODE'
echo '             1 - WinkStart (default)'
echo '             2 - LoopStart'
echo '             3 - GroundStart'
echo ' -------------------------------------------------------------------------------'
echo -e "Your selection (1...3)[1]: \c"
read pri_rbscas_trunk_mode
if [ -z $pri_rbscas_trunk_mode ]
then
pri_rbscas_trunk_mode=1
fi
case $pri_rbscas_trunk_mode in
  1) pri_rbscas_trunk_mode=0
   ;;
  2) pri_rbscas_trunk_mode=1
   ;;
  3) pri_rbscas_trunk_mode=2
   ;;
  *) pri_rbscas_trunk_mode=257
   ;;
esac
}

# ----------------------------------------------------------------------------
#  RBAS CAS DIAL TYPE
# ----------------------------------------------------------------------------
pri_get_rbscas_trunk_dial_type()
{
clear
echo ' -------------------------------------------------------------------------------'
echo '             DIAL TYPE'
echo '             1 - Pulse'
echo '             2 - DTMF (Dual-Tone Multifrequency Signaling, default)'
echo '             3 - MF   (Multifrequency Signaling)'
echo ' -------------------------------------------------------------------------------'
echo -e "Your selection (1..3)[2]: \c"
read pri_rbscas_trunk_dial_type
if [ -z $pri_rbscas_trunk_dial_type ]
then
pri_rbscas_trunk_dial_type=2
fi
case $pri_rbscas_trunk_dial_type in
  1) pri_rbscas_trunk_dial_type=0
   ;;
  2) pri_rbscas_trunk_dial_type=1
   ;;
  3) pri_rbscas_trunk_dial_type=2
   ;;
  *) pri_rbscas_trunk_dial_type=257
   ;;
esac
}

# ----------------------------------------------------------------------------
#  RBAS CAS DIDD
# ----------------------------------------------------------------------------
pri_get_rbscas_didd()
{
clear
echo ' -------------------------------------------------------------------------------'
echo '             ASSUME CALLED PARTY ACCEPTS CALL IMMEDIATELLY AFTER'
echo '             OFF HOOK CONDITION (DO NOT SEND DIALING DIGITS) ?'
echo ' -------------------------------------------------------------------------------'
echo -e "Your selection (Y/N)[N]: \c"
read pri_rbscas_didd
if [ -z $pri_rbscas_didd ]
then
pri_rbscas_didd="N"
fi
case $pri_rbscas_didd in
  Y) pri_rbscas_didd=1
    ;;
  y) pri_rbscas_didd=1
    ;;
  N) pri_rbscas_didd=0
    ;;
  n) pri_rbscas_didd=0
    ;;
  *) pri_rbscas_didd=257
    ;;
esac
}

# ----------------------------------------------------------------------------
#  Generate local tones
# ----------------------------------------------------------------------------
pri_get_ringer_tone()
{
clear
echo ' -------------------------------------------------------------------------------'
echo '             GENERATE LOCAL TONES (ALERT/BUSY) IN B-CHANNEL'
echo '             IN CASE TONES ARE NOT PROVIDED BY ISDN EQUIPMENT ?'
echo ' -------------------------------------------------------------------------------'
echo -e "Your selection (Y/N)[N]: \c"
read pri_ringer_tone
if [ -z $pri_ringer_tone ]
then
pri_ringer_tone="N"
fi
case $pri_ringer_tone in
  Y) pri_ringer_tone=1
    ;;
  y) pri_ringer_tone=1
    ;;
  N) pri_ringer_tone=0
    ;;
  n) pri_ringer_tone=0
    ;;
  *) pri_ringer_tone=255
    ;;
esac
}

# ----------------------------------------------------------------------------
#  Get force Law Options
# ----------------------------------------------------------------------------
pri_law_options()
{
clear
echo ' -------------------------------------------------------------------------------'
echo '                PLEASE SELECT LAW OPTIONS'
echo ' -------------------------------------------------------------------------------'
echo " 0 - NATIONAL DEFAULT (dependent on selected D-channel protocol)"
echo " 1 - force A-Law"
echo " 2 - force u-Law"
echo ' -------------------------------------------------------------------------------'
echo -e "Your selection [0]: \c"
read law_options
if [ -z $law_options ]
then
law_options=0
fi
case $law_options in
 0)
  ;;
 1)
  ;;
 2)
  ;;
 *) law_options=100
  ;;
esac
}

# ----------------------------------------------------------------------------
#  Get L1 Options
# ----------------------------------------------------------------------------
pri_l1_options()
{
clear
echo ' -------------------------------------------------------------------------------'
echo '                PLEASE SELECT LAYER 1 OPTIONS'
echo ' -------------------------------------------------------------------------------'
echo " 0 - NATIONAL DEFAULT (dependent on selected D-channel protocol)"
echo " 1 - doubleframing (NO CRC4)"
echo " 2 - multiframing  (CRC4)"
echo " 3 - autodetection"
echo ' -------------------------------------------------------------------------------'
echo -e "Your selection [0]: \c"
read l1_options
if [ -z $l1_options ]
then
l1_options=0
fi
case $l1_options in
 0)
  ;;
 1)
  ;;
 2)
  ;;
 3)
  ;;
 *) l1_options=4
  ;;
esac
}

pri_z_options()
{
clear
echo ' -------------------------------------------------------------------------------'
echo '  Set adapter to high impedance state until first user application'
echo '  requests interface activation.'
echo '  ATTENTION: Please select 'Yes' only if you have configured your PABX'
echo "  for this operation (e.g. Hunt Group)."
echo ' -------------------------------------------------------------------------------'
echo -e " Your selection (Y/N)[N]: \c"
read z_options
if [ -z $z_options ]
then
z_options="N"
fi
case $z_options in
 Y) z_options=1
  ;;
 y) z_options=1
  ;;
 N) z_options=0
  ;;
 n) z_options=0
  ;;
 *) z_options=2
  ;;
esac
}

pri_use_nt2()
{
clear
echo ' -------------------------------------------------------------------------------'
echo "              SELECT NT2 (DIRECT DIAL IN, DIRECT INWARD DIALING) MODE ?"
echo ' -------------------------------------------------------------------------------'
if [ $((protocol)) -eq $((2)) ]
then
echo -e " Your selection (Y/N)[Y]: \c"
else
echo -e " Your selection (Y/N)[N]: \c"
fi
read nt2_mode
if [ -z $nt2_mode ]
then
  if [ $((protocol)) -eq $((2)) ]
  then
    nt2_mode="Y"
  else
    nt2_mode="N"
  fi
fi
case $nt2_mode in
 Y) nt2_mode=1
  ;;
 y) nt2_mode=1
  ;;
 N) nt2_mode=0
  ;;
 n) nt2_mode=0
  ;;
 *) nt2_mode=2
  ;;
esac
}

pri_didn_length()
{
clear
echo ' -------------------------------------------------------------------------------'
echo '             PLEASE ENTER DIRECT INWARD DIALING NUMBER LENGTH'
echo ' -------------------------------------------------------------------------------'
echo -e "Please enter a number (0...20)[0]: \c"
read didn_length
if [ -z $didn_length ]
then
didn_length=0
fi
case $didn_length in
  0)
   ;;
  1)
   ;;
  2)
   ;;
  3)
   ;;
  4)
   ;;
  5)
   ;;
  6)
   ;;
  7)
   ;;
  8)
   ;;
  9)
   ;;
 10)
   ;;
 11)
   ;;
 12)
   ;;
 13)
   ;;
 14)
   ;;
 15)
   ;;
 16)
   ;;
 17)
   ;;
 18)
   ;;
 19)
   ;;
 20)
   ;;

  *) didn_length=100
   ;;
esac
}

# -----------------------------------------------------------------------------
#  ASC FOR FRACTIONAL E1/T1
# -----------------------------------------------------------------------------
pri_lo_channel_yes_no()
{
clear
echo ' -------------------------------------------------------------------------------'
echo "              DO YOU USE A FRACTIONAL E1/T1 LINE ?"
echo ' -------------------------------------------------------------------------------'
echo -e " Your selection (Y/N)[N]: \c"
read pri_fractional_yes
if [ -z $pri_fractional_yes ]
then
pri_fractional_yes="N"
fi
case $pri_fractional_yes in
  Y) pri_fractional_yes=1
   ;;
  y) pri_fractional_yes=1
   ;;
  N) pri_fractional_yes=0
   ;;
  n) pri_fractional_yes=0
   ;;
  *) pri_fractional_yes=2
   ;;
esac
}

pri_get_lo_channel_number()
{
clear
echo ' -------------------------------------------------------------------------------'
echo "              PLEASE ENTER THE LOWEST AVAILABLE CHANNEL"
echo ' -------------------------------------------------------------------------------'
echo -e "Please enter a number [1...$pri_num_channels]: \c"
read pri_lo_channel
case $pri_lo_channel in
  1)
   ;;
  2)
   ;;
  3)
   ;;
  4)
   ;;
  5)
   ;;
  6)
   ;;
  7)
   ;;
  8)
   ;;
  9)
   ;;
 10)
   ;;
 11)
   ;;
 12)
   ;;
 13)
   ;;
 14)
   ;;
 15)
   ;;
 16)
   ;;
 17)
   ;;
 18)
   ;;
 19)
   ;;
 20)
   ;;
 21)
   ;;
 22)
   ;;
 23)
   ;;
 24)
   ;;
 25)
   ;;
 26)
   ;;
 27)
   ;;
 28)
   ;;
 29)
   ;;
 30)
   ;;
  *) pri_lo_channel=100
   ;;
esac

if [ $((pri_lo_channel)) -ge $(($pri_num_channels+1)) ]
then
pri_lo_channel=100
fi
}


pri_ext_options()
{
clear
echo ' -------------------------------------------------------------------------------'
echo '              DO YOU WISH TO CONFIGURE ADVANCED PARAMETERS ?'
echo ' -------------------------------------------------------------------------------'
echo -e " Your selection (Y/N)[N]: \c"
read ext_options
if [ -z $ext_options ]
then
ext_options="N"
fi
case $ext_options in
 Y) ext_options=1
  ;;
 y) ext_options=1
  ;;
 N) ext_options=0
  ;;
 n) ext_options=0
  ;;
 *) ext_options=2
  ;;
esac
}

pri_own_tei_yes_no()
{
clear
echo ' -------------------------------------------------------------------------------'
echo '                    DO YOU USE STANDARD TEI ? (YES)'
echo ' -------------------------------------------------------------------------------'
echo -e "Your selection (Y/N)[Y]: \c"
read pri_own_tei_yes
if [ -z $pri_own_tei_yes ]
then
pri_own_tei_yes="Y"
fi
case $pri_own_tei_yes in
  Y) pri_own_tei_yes=0
   ;;
  y) pri_own_tei_yes=0
   ;;
  N) pri_own_tei_yes=1
   ;;
  n) pri_own_tei_yes=1
   ;;
  *) pri_own_tei_yes=2
   ;;
esac
}

pri_own_tei=100
pri_get_tei_number()
{
local nr=0
clear
echo ' -------------------------------------------------------------------------------'
echo '                     PLEASE ENTER TEI VALUE [0...63]'
echo ' -------------------------------------------------------------------------------'
echo -e "TEI value [0]: \c"
read pri_own_tei
if [ -z $pri_own_tei ]
then
pri_own_tei="0"
fi
nr=$((pri_own_tei))
if [ $nr != $pri_own_tei ]
then
pri_own_tei=100
else
 if [ $nr -ge 64 ]
 then
  pri_own_tei=100
 fi
fi
}

# ----------------------------------------------------------------------------
#  MAIN ()
# ----------------------------------------------------------------------------
# --------------------------------------------------------------------------
#  ASK FOR GENERIC PROFILE
# --------------------------------------------------------------------------
while [ $generic_profile -eq 0 ]
do
 divas_pri_generic_profile
done

# --------------------------------------------------------------------------
#  ASK FOR D-CHANNEL PROTOCOL
# --------------------------------------------------------------------------
while [ $protocol -eq 0 ]
do
 divas_pri_protocol
done

# --------------------------------------------------------------------------
#  ASK FOR EXTENDED CONFIGURATION
# --------------------------------------------------------------------------
while [ $ext_options -eq 2 ]
do
 pri_ext_options
done

# --------------------------------------------------------------------------
#  START OF EXT OPTIONS
# --------------------------------------------------------------------------
if [ $ext_options -eq 1 ]
then

if [ $pri_num_channels -eq 30 ]
then
while [ $nt2_mode -eq 2 ]
do
 pri_use_nt2
done
else
nt2_mode=0
fi

if [ $((protocol)) -eq 19 ]
then
  nt2_mode=1

  while [ $((pri_rbscas_rx_digit_to)) -eq 257 ]
  do
  pri_get_rbscas_rx_digit_to
  done

  while [ $((pri_rbscas_glare)) -eq 257 ]
  do
    pri_get_rbscas_glare
  done

  while [ $((pri_rbscas_bc)) -eq 257 ]
  do
    pri_get_rbscas_bc
  done

  while [ $((pri_rbscas_answer_to)) -eq 257 ]
  do
    pri_get_rbscas_answer_to
  done

  while [ $((pri_rbscas_trunk_mode)) -eq 257 ]
  do
    pri_get_rbscas_trunk_mode
  done

  while [ $((pri_rbscas_trunk_dial_type)) -eq 257 ]
  do
    pri_get_rbscas_trunk_dial_type
  done

  if [ $((pri_rbscas_trunk_dial_type)) -eq 0 ]
  then
    if [ $((generic_profile)) -eq 2 ]
    then
	    while [ $((pri_rbscas_didd)) -eq 257 ]
      do
        pri_get_rbscas_didd
      done
    fi
  fi
fi

if [ $nt2_mode -eq 1 ]
then
  while [ $didn_length -eq 100 ]
  do
    pri_didn_length
  done
fi

if [ $((protocol)) -eq 19 ]
then
l1_options=0
fi
while [ $l1_options -eq 4 ]
do
 pri_l1_options
done

while [ $law_options -eq 100 ]
do
 pri_law_options
done

while [ $z_options -eq 2 ]
do
 pri_z_options
done

while [ $pri_fractional_yes -eq 2 ]
do
pri_lo_channel_yes_no
done

if [ $pri_fractional_yes -eq 1 ]
then
  while [ $pri_lo_channel -eq 100 ]
  do
  pri_get_lo_channel_number
  done
fi

while [ $pri_own_tei_yes -eq 2 ]
do
pri_own_tei_yes_no
done

if [ $pri_own_tei_yes -eq 1 ]
then
  while [ $pri_own_tei -eq 100 ]
  do
  pri_get_tei_number
  done
fi

while [ $((pri_ringer_tone)) -eq 255 ]
do
pri_get_ringer_tone
done

else
# -------------------------------------------------------------------------
#  SET DEFAULTS FOR EXTENDED OPTIONS
# -------------------------------------------------------------------------
z_options=0
l1_options=0

if [ $((nt2_mode)) -eq 2 ]
then
  nt2_mode=1
fi

didn_length=0
pri_fractional_yes=0
pri_own_tei_yes=0
law_options=0
pri_ringer_tone=0
fi
# --------------------------------------------------------------------------
#  END OF EXT OPTIONS
# --------------------------------------------------------------------------

# -----------------------------------------------------------------------------
#  SET BASIS LOAD OPTIONS
# -----------------------------------------------------------------------------
if [ -f $diva_dir/divactrl ]
then
load_command=$diva_dir
else
load_command=/sbin
fi
load_command="$load_command/divactrl load -c $adapter -f $protocol_string"

# -----------------------------------------------------------------------------
#  ADD L1 OPTIONS
# -----------------------------------------------------------------------------
if [ $l1_options != 0 ]
then
load_command="$load_command -e $l1_options"
fi

# -----------------------------------------------------------------------------
#  ADD LAW OPTIONS
# -----------------------------------------------------------------------------
if [ $law_options != 0 ]
then
load_command="$load_command -m $law_options"
fi

# -----------------------------------------------------------------------------
#  ADD Z OPTIONS
# -----------------------------------------------------------------------------
if [ $z_options != 0 ]
then
load_command="$load_command -z"
echo "echo 1 > $eicon_proc/adapter$((adapter))/dynamic_l1_down" >> $diva_dir/diva_capi_dynamic_l1_file
fi

# ----------------------------------------------------------------------------
#  ADD GENERIC PROFILE OPTIONS
# ----------------------------------------------------------------------------
case $generic_profile in
  1)
     ;;
  2) load_command="$load_command -x"
     ;;
  3) load_command="$load_command -p 1"
     ;;
  4) load_command="$load_command -p 2"
     ;;
  5) load_command="$load_command -p 2 -x"
     ;;
esac

# ---------------------------------------------------------------------------
#  ADD NT2 AND DIDN
# ---------------------------------------------------------------------------
if [ $nt2_mode -eq 1 ]
then
 if [ $didn_length -eq 0 ]
 then
  load_command="$load_command -n 0"
 else
  load_command="$load_command -n $didn_length"
 fi
fi

# ---------------------------------------------------------------------------
#  ADD FRACTIONAL T1/E1/CHANNEL ALLOCATION STRATEGY OPTIONS
# ---------------------------------------------------------------------------
if [ $pri_fractional_yes -eq 1 ]
then
load_command="$load_command -l $pri_lo_channel -Fractional 1"
fi

# ---------------------------------------------------------------------------
#  TEI SELECTION, EXTENDED OPTIONS
# ---------------------------------------------------------------------------
if [ $pri_own_tei_yes -eq 1 ]
then
load_command="$load_command -t $pri_own_tei"
fi

# ---------------------------------------------------------------------------
#  RINGER TONE SELECTION, EXTENDED OPTIONS
# ---------------------------------------------------------------------------
if [ $((pri_ringer_tone)) -eq 1 ]
then
load_command="$load_command -RingerTone 1"
fi

# ---------------------------------------------------------------------------
#  RBS CAS DIDD
# ---------------------------------------------------------------------------
if [ $((pri_rbscas_didd)) -ne 257 ]
then
load_command="$load_command -RbsDID $pri_rbscas_didd"
fi

# ---------------------------------------------------------------------------
#  RBS CAS RX DIGIT TIMEOUT
# ---------------------------------------------------------------------------
if [ $((pri_rbscas_rx_digit_to)) -ne 257 ]
then
load_command="$load_command -RbsDigitTimeout $pri_rbscas_rx_digit_to"
fi

# ---------------------------------------------------------------------------
#  RBS CAS GLARE RESOLVE
# ---------------------------------------------------------------------------
if [ $((pri_rbscas_glare)) -ne 257 ]
then
load_command="$load_command -RbsGlareResolve $pri_rbscas_glare"
fi

# ---------------------------------------------------------------------------
#  RBS CAS BC
# ---------------------------------------------------------------------------
if [ $((pri_rbscas_bc)) -ne 257 ]
then
load_command="$load_command -RbsBearerCap $pri_rbscas_bc"
fi

# ---------------------------------------------------------------------------
#  RBS CAS ANSWER TIMEOUT
# ---------------------------------------------------------------------------
if [ $((pri_rbscas_answer_to)) -ne 257 ]
then
load_command="$load_command -RbsAnswerDelay $pri_rbscas_answer_to"
fi

# ---------------------------------------------------------------------------
#  RBS CAS TRUNK MODE
# ---------------------------------------------------------------------------
if [ $((pri_rbscas_trunk_mode)) -ne 257 ]
then
load_command="$load_command -RbsTrunkMode $pri_rbscas_trunk_mode"
fi

# ---------------------------------------------------------------------------
#  RBS CAS TRUNK MODE
# ---------------------------------------------------------------------------
if [ $((pri_rbscas_trunk_dial_type)) -ne 257 ]
then
load_command="$load_command -RbsDialType $pri_rbscas_trunk_dial_type"
fi

# ----------------------------------------------------------------------------
#  ADD LOAD STRING TO THE PRI LOAD SCRIPT
# ----------------------------------------------------------------------------
clear
echo $load_command >> $diva_dir/divas_cfg.rc

